package main

import (
	"cicv_data_closedloop/pjisuv_msgs"
	"fmt"
	"sync"
)

var (
	Framenum             int64 = 0
	YawofCicvLocation    any
	ObjDicOfTpperception any
	objDic               = make(map[uint32][][]float32)
	yaw                  float64
	objId                uint32
	obj                  [][]float32
	ok1                  bool
	ok2                  bool
	ObjectSlice          = make(map[uint32][][]float32)
)

func isCross(ObjectList [][]float32) bool {
	for i := 0; i < len(ObjectList[0]); i++ {
		Type := ObjectList[6][0]
		xi := ObjectList[0][i]
		yi := ObjectList[1][i]
		diff_hi := ObjectList[7][i]
		if xi >= 0 && yi >= 2 && diff_hi > 0 && Type != 100.0 { //简化条件
			//if xi >= 0 && yi >= 2 && diff_hi <= 120 && diff_hi >= 60 && Type != 1.0 {//理论条件
			for j := 0; j < len(ObjectList[0])-i-1; j++ {
				xj := ObjectList[0][j]
				yj := ObjectList[1][j]
				diff_hj := ObjectList[7][j]
				if xj >= 0 && yj <= -2 && diff_hj > 0 { //简化条件
					//if xj >= 0 && yj <= -2 && diff_hj <= 120 && diff_hj >= 60 {//理论条件
					return true
				}
			}
		}
	}
	return false
}

func Topic() string {
	return "/tpperception"
}

// 禁止存在下划线_
func Label() string {
	return "CCCscpf"
}

func Rule(shareVars *sync.Map, data *pjisuv_msgs.PerceptionObjects) string {
	defer func() {
		if r := recover(); r != nil {
			fmt.Println("Recovered from panic:", r)
		}
	}()
	YawofCicvLocation, ok1 = shareVars.Load("YawOfCicvLocation")
	if !ok1 {
		return ""
	}
	yaw = YawofCicvLocation.(float64)
	Framenum += 1
	ObjDicOfTpperception, ok2 = shareVars.Load("ObjDicOfTpperception")
	if !ok2 {
		return ""
	}
	objDic = ObjDicOfTpperception.(map[uint32][][]float32)
	for _, objValue := range objDic {
		if len(objValue[0]) <= 10 || !isCross(objValue) {
			continue
		}
		return Label()
	}
	return ""
}
